/*--------------------------------------------------------------


	T I F A C S    : Tiff 4.0-Bibliothek von Aldus,
			 angepasst und erweitert von Bernd Herd
						     Rudolf-Virchow-Str. 8
						     6842 Brstadt

			 Siehe TIFACS.DOC fr Copyright-Infos

	R E A D H D R . C : Tiff-Header aus File lesen

  --------------------------------------------------------------*/
#include "tiff.h" 		// Anwendungs-Include-Datei
#include "tiffi.h"		// Interne Include-Datei
#include "io.h"

extern LONG bigRead();
extern LONG lseek();
extern BOOL correct_version();

BOOL _TIFF_reorder_bytes = FALSE;

/* read TIFF file header record */

/* read_header ---------------------------------------------------------*
 *   HEader der Tiff-Datei lesen, Datei an den Anfang positionieren	*
 *----------------------------------------------------------------------*/
SHORT read_header(SHORT fhandle, LPTIFF_HEADER header_buff)
{
	LONG nbytes;

	/* make sure buffer isn't null */
	if(!header_buff)
	{
		return(0);
	}

	/* seek to start of file */
	if(lseek(fhandle, 0L, 0) == (LONG)(-1))
	{
		return(0);
	}

	/* do the read */
	nbytes = bigRead(fhandle, (LONGPTR) header_buff, (LONG)TIFF_HEADER_SIZE);
	if(nbytes != TIFF_HEADER_SIZE)
	{
		return(0);
	}

	/* reorder the bytes, if necessary */
	switch(header_buff->byte_order)
	{
	case INTEL:
		_TIFF_reorder_bytes = FALSE;
		break;

	case MOTOROLA:
		_TIFF_reorder_bytes = TRUE;
		break;

	default:		/* illegal byte order flag */
		return(0);
	}

	/* routine does nothing unless the _TIFF_reorder_bytes flag is set */
	reorder((LONGPTR)&(header_buff->version), SHORT_SIZE);
	reorder((LONGPTR)&(header_buff->dir_offset), LONG_SIZE);

	/* make sure version is correct */
	if(!correct_version(header_buff->version))
	{
		return(0);
	}

	return(LOWORD(nbytes));
}
