/*-------------------------------------------------------

	T I F F A C S : Untersttzungsroutinen fr TIFF-Dateien
			Ursprnglich von Aldus, von mir auf dem
			Walnut-Creek - Source-Code-ROM gefunden.

			Der ursprngliche Source ist TIFF 4.0 und
			auch ansonsten ein ziemlicher Mll.

			Diese Version hat Funktionsprototypen und
			ein paar Fehler weniger, aber im Grunde ist
			sie auch ein ziemlicher Mll.

			Im Mircosoft System Journal 4/93 ist eine ganz
			brauchbare TIF-Routine dabei, aber eben nicht PD

			Bernd Herd
			Rudolf Virchow Str. 8
			6842 Brstadt
			06206/79222

       U N P A C K B I: Dekompression zur PackBits-Kompression

  -------------------------------------------------------------*/



#include <windows.h>
#pragma hdrstop
#include <string.h>
#include "tiff.h"
#include "tiffi.h"


/*----------------------------------------------------------------------

	UnpackBits : Dekomprimiert einen Puffer in PackBits-Kompression

	Parameter  : plpSrc	: Quell-Zeiger
		     plpDst	: Ziel-Zeiger
		     dstBytes	: Anzahl Bytes im Ziel-Puffer

	Rckgabe   : FALSE	: Fehler
		     TRUE	: OK			     	

  ----------------------------------------------------------------------*/
BOOL UnpackBits (LONGPTR plpSrc, LONGPTR plpDst, SHORT dstBytes)
{
		register LONGPTR	lpSrc = plpSrc;
		register LONGPTR	lpDst = plpDst;
		register signed char	cc;
		register SHORT		count;
		register SHORT		outsofar = 0;

		while (outsofar < dstBytes) {

			cc = *((signed char FAR *)lpSrc)++;

			if (cc != -128)

			/* if -127 <= BYTE <= -1, replicate the next byte -n+1 times
			 */
			if (cc & 0x80) {
				count = -((signed int)cc) + 1;	/* relies on sign-extension!!! */
				outsofar += count;

				if (outsofar > dstBytes) return FALSE;

				memset (lpDst, (BYTE)*lpSrc, (WORD)count);
				lpSrc++;
			}

			/* else if 0 <= BYTE <= 127, copy the next n+1 bytes literally
			 */
			else {
				count = (SHORT)cc + 1;
				outsofar += count;
				if (outsofar > dstBytes) return FALSE;
				memcpy (lpDst, lpSrc, (WORD)count);
				lpSrc += count;
			}
			lpDst += count;
		}
	return TRUE;
}
